//
//  LineView.m
//  EmbedText
//
//  Created by 兖志飞 on 16/4/18.
//  Copyright © 2016年 兖志飞. All rights reserved.
//

#import "LineView.h"
#define SPACINGX 35.0
#define SPACINGY 30.0
@implementation LineView


- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        //self.backgroundColor = [UIColor Color];
        self.num=0;
        NSArray *array1 = @[@"51",@"74",@"120",@"98",@"74",@"123",@"99"];
         NSArray *ary2 = @[@"116",@"163",@"64",@"123",@"190",@"164",@"130"];
         self.array = [NSMutableArray array];
        //[self.array addObject:array1];
        [self.array addObject:ary2];
    }
    return self;
}
- (void)layoutSubviews{
    [self drawXY];
    
    for (NSArray *ary in self.array) {
        self.num++;
        NSLog(@"%f",self.num);
        CAShapeLayer *layer = [CAShapeLayer layer];
        layer.frame         = self.bounds;                // 与showView的frame一致
        layer.strokeColor   = [UIColor colorWithRed:0.5*self.num/3.0 green:0.7  blue:self.num/3.0  alpha:1].CGColor;
       
        layer.fillColor     = [UIColor clearColor].CGColor;   // 闭环填充的颜色
        layer.lineCap       = kCALineCapSquare;               // 边缘线的类型                // 从贝塞尔曲线获取到形状
        layer.lineWidth     = 2.0f;
        UIBezierPath*path=[UIBezierPath new];
         float str = [ary[0] floatValue];
        str = [self Mactfloat:str];
        [path moveToPoint:CGPointMake(SPACINGX,str)];
        NSLog(@"%f",self.frame.size.width);
        float spacing = (self.frame.size.width - 2*SPACINGX)/(ary.count - 1);
        for (int i = 1; i< ary.count; i++) {
            
            float t = [ary[i] floatValue];
             t = [self Mactfloat:t];
            [path addLineToPoint:CGPointMake(spacing*i+SPACINGX,t)];
            [self addPoint:CGPointMake(spacing*i+SPACINGX,t) isShow:NO value:t title:ary[i] color:layer.strokeColor];
        }

    layer.path=path.CGPath;
    [self.layer addSublayer:layer];
    [self AddCabasicAnimation:3 CaShapeLayer:layer];
    }

}
// 计算坐标

- (CGFloat )Mactfloat:(CGFloat)num{
    num = self.frame.size.height-SPACINGY - (num-50)/150.0*(self.frame.size.height - 2*SPACINGY);
    return num;
}
//动画
- (void)AddCabasicAnimation:(float )time CaShapeLayer:(CAShapeLayer *)layer{
    CABasicAnimation *pathAnimation = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    pathAnimation.duration =time;
    pathAnimation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    pathAnimation.fromValue = [NSNumber numberWithFloat:0.0f];
    pathAnimation.toValue = [NSNumber numberWithFloat:1.0f];
    pathAnimation.autoreverses = NO;
    [layer addAnimation:pathAnimation forKey:@"strokeEndAnimation"];

}
// 还坐标
- (void)drawXY{
    CAShapeLayer *layer = [CAShapeLayer layer];
    layer.lineWidth = 2;
    //layer.fillColor = [UIColor grayColor].CGColor;
    layer.lineCap       = kCALineCapSquare;
    layer.strokeColor = [UIColor colorWithRed:0.3 green:0.3 blue:0.3 alpha:1].CGColor;
    UIBezierPath *path = [UIBezierPath bezierPath];
    [path moveToPoint:CGPointMake(SPACINGX,self.frame.size.height - SPACINGY)];
    [path addLineToPoint:CGPointMake(SPACINGX, SPACINGY)];
    [path moveToPoint:CGPointMake(SPACINGX,self.frame.size.height - SPACINGY)];
    [path addLineToPoint:CGPointMake(self.frame.size.width-SPACINGY, self.frame.size.height - SPACINGY)];
    layer.path = path.CGPath;
    [self.layer addSublayer:layer];
    
    for (int i = 0; i < 7; i++) {
        UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 0,  (self.frame.size.width - 2*SPACINGX)/6, 30)];
        label.font = [UIFont systemFontOfSize:12];
        label.center = CGPointMake((self.frame.size.width - 2*SPACINGX)/6 * i + SPACINGX ,self.frame.size.height - SPACINGY/2);
        label.textAlignment = NSTextAlignmentCenter;
        label.textColor = self.backgroundColor;
        //label.backgroundColor = [UIColor greenColor];
        label.text = [NSString stringWithFormat:@"星期%d",i+1];
        [self addSubview:label];
    }
    for (int i = 0; i < 7; i++) {
        UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, SPACINGX, 30)];
        label.font = [UIFont systemFontOfSize:12];
        label.center = CGPointMake(SPACINGX/2-3,self.frame.size.height - (self.frame.size.height - 2*SPACINGY)/6 * i-SPACINGY);
        label.textAlignment = NSTextAlignmentRight;
        label.textColor = self.backgroundColor;
        //label.backgroundColor = [UIColor greenColor];
        label.text = [NSString stringWithFormat:@"%0.1f",150 /6.0*i +50];
        [self addSubview:label];
    }
    
}

//

// 显示数字；
- (void)addPoint:(CGPoint)point isShow:(BOOL)isHollow value:(CGFloat)value title:(NSString *)tittle color:(CGColorRef)color
    {
        UIView *view = [[UIView alloc]initWithFrame:CGRectMake(5, 5, 8, 8)];
        view.center = point;
        view.layer.masksToBounds = YES;
        view.layer.cornerRadius = 4;
        if (isHollow) {
            view.backgroundColor = [UIColor clearColor];
        }else{
            view.layer.backgroundColor = color;
            UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(5, 5, 30, 10)];
           label.font = [UIFont systemFontOfSize:10];
            label.center = CGPointMake(point.x, point.y - 8);
           label.textAlignment = NSTextAlignmentCenter;
            label.textColor = view.backgroundColor;
            //label.backgroundColor = [UIColor greenColor];
            label.text = [NSString stringWithFormat:@"%@",tittle];
           [self addSubview:label];
        }
        
        [self addSubview:view];
    }


@end
